
.386 
.model flat, stdcall 
option casemap:none 

VWIN32_DIOC_DOS_DRIVEINFO EQU 6
; Performs Interrupt 21h Function 730X commands.
; This value is supported in Windows 95 OEM Service Release 2 and later. 

include c:\masm32\include\windows.inc 
include c:\masm32\include\kernel32.inc 
includelib c:\masm32\lib\kernel32.lib 
include c:\masm32\include\user32.inc 
includelib c:\masm32\lib\user32.lib 


;DeviceIOControl(kernel32) VxD
;-----------------------------------


DIOCRegs STRUC 
reg_EBX DD 0 
reg_EDX DD 0 
reg_ECX DD 0 
reg_EAX DD 0 
reg_EDI DD 0 
reg_ESI DD 0 
reg_Flags DD 0 
DIOCRegs ENDS 


.data 


; hDevice = CreateFile("\\\\.\\vwin32",... 

VxDFileName db '\\.\vxdint',0 ; VxD 
AppName db "DeviceIoControl",0 
Success db "The VxD is successfully loaded!",0 
Failure db "The VxD is not loaded!",0 
Unload db "The VxD is now unloaded!",0 

;DIOCRegs 

DeviceIOCallStructure DIOCRegs <>

CB dd 0 				; Unknown buffer for DeviceIOControl 

; MessageBox 
MsgErrDeviceIO          db "Error at DeviceIOControl execution ! ;)",0 
MsgErrReadSector        db "Raising Error ???????? at read sector ! ;)",0 
MsgDeviceIOControl      db "DeviceIOControl example: read disk sector",0 
MsgOk                   db "Sector number ???????? at Drive ???????? contain: ???????? at begin and ???????? at the end.",0 

.data? 

;VxD (vwin32) 
;------------------
hVxD dd ?
.code 
start: 

; Device IO Control 
;  "VxD" 

invoke CreateFile,addr VxDFileName,0,0,0,0,FILE_FLAG_DELETE_ON_CLOSE,0
cmp eax,INVALID_HANDLE_VALUE 
jz ResultDone 

; ID  VxD 
;----------------
mov hVxD,eax

;(VxD)
;---------------
invoke MessageBox,NULL,addr Success,addr AppName,MB_OK+MB_ICONINFORMATION 



; VxD ????? DeviceIOControl 
;mov DeviceIOCallStructure.reg_EAX,  5305h ; DOS Abs_Disk_Read 
;mov DeviceIOCallStructure.reg_EBX,   ;offset CallParams ; = (DWORD)&dio; 
;mov DeviceIOCallStructure.reg_ECX,-1 ; use DISKIO struct 
;mov DeviceIOCallStructure.reg_ESI,0 ; Read (for write - 1) 
;mov DeviceIOCallStructure.reg_EDX,0 ; Drive Number = 0=Default,1="A",2="B"... 
mov DeviceIOCallStructure.reg_EAX,4c00h;



;  DeviceIOControl 
push NULL 
push offset CB 
push size DeviceIOCallStructure 
push offset DeviceIOCallStructure 
push size DeviceIOCallStructure 
push offset DeviceIOCallStructure 
push 1; NULL; VWIN32_DIOC_DOS_DRIVEINFO 
push hVxD 
call DeviceIoControl 




; ???? 
;mov eax,DeviceIOCallStructure.reg_EAX 
ResultDone: 
invoke CloseHandle,hVxD 
invoke MessageBox,NULL,addr Unload,addr AppName,MB_OK+MB_ICONINFORMATION 
invoke ExitProcess,NULL 
end start 
 

